/*
 *	 libodbc.h
 *	 Generated by sql2class v1.8.1 by (C) AH 2000-2006
 *	  using command line
 *	  $ sql2class -global- -lib libodbc -namespace sql -overwrite odbc.sql -odbc
 *	 Date: Fri Mar 31 10:05:11 2006
 */

/*
Copyright (C) 2001-2006  Anders Hedstrom (grymse@alhem.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <afxdb.h>
#include <sql.h>
#include <libodbcwrapped.h>
#include <map>

#include <vector>
#include <string>

#ifndef _LIBODBC_H
#define _LIBODBC_H

#ifdef _WIN32
#define strncasecmp strnicmp
#define strcasecmp stricmp
#endif // _WIN32

/**
 **  Class 'Odbctable' and 'cOdbctable'
 **/

namespace sql
{
class Odbctable {
public:
	Odbctable(Database *);
	Odbctable(Database *,const std::string& );
	Odbctable(Database *,Query *,int = 0 /* offset */);
	~Odbctable();
	unsigned __int64 insert();
	void save();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	const char *GetTable_cat() { return this -> table_cat.c_str(); }
	void SetTable_cat(const std::string&  x) { this -> table_cat = x; }
	const char *GetTable_schem() { return this -> table_schem.c_str(); }
	void SetTable_schem(const std::string&  x) { this -> table_schem = x; }
	const char *GetTable_name() { return this -> table_name.c_str(); }
	void SetTable_name(const std::string&  x) { this -> table_name = x; }
	const char *GetTable_type() { return this -> table_type.c_str(); }
	void SetTable_type(const std::string&  x) { this -> table_type = x; }
	const char *GetRemarks() { return this -> remarks.c_str(); }
	void SetRemarks(const std::string&  x) { this -> remarks = x; }

	// table columns
private:
	std::string              table_cat; // varchar(255)
	std::string              table_schem; // varchar(255)
	std::string              table_name; // varchar(255)
	std::string              table_type; // varchar(255)
	std::string              remarks; // varchar(255)
	//
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	//
	Database *database;
	short new_object;
}; // End of class 'Odbctable'

} // end of namespace

/**
 **  Class 'Odbccolumn' and 'cOdbccolumn'
 **/

namespace sql
{
class Odbccolumn {
public:
	Odbccolumn(Database *);
	Odbccolumn(Database *,const std::string& );
	Odbccolumn(Database *,Query *,int = 0 /* offset */);
	~Odbccolumn();
	unsigned __int64 insert();
	void save();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	const char *GetTable_cat() { return this -> table_cat.c_str(); }
	void SetTable_cat(const std::string&  x) { this -> table_cat = x; }
	const char *GetTable_schem() { return this -> table_schem.c_str(); }
	void SetTable_schem(const std::string&  x) { this -> table_schem = x; }
	const char *GetTable_name() { return this -> table_name.c_str(); }
	void SetTable_name(const std::string&  x) { this -> table_name = x; }
	const char *GetColumn_name() { return this -> column_name.c_str(); }
	void SetColumn_name(const std::string&  x) { this -> column_name = x; }
	short GetData_type() { return this -> data_type; }
	void SetData_type(short x) { this -> data_type = x; }
	const char *GetType_name() { return this -> type_name.c_str(); }
	void SetType_name(const std::string&  x) { this -> type_name = x; }
	long GetColumn_size() { return this -> column_size; }
	void SetColumn_size(long x) { this -> column_size = x; }
	long GetBuffer_length() { return this -> buffer_length; }
	void SetBuffer_length(long x) { this -> buffer_length = x; }
	short GetDecimal_digits() { return this -> decimal_digits; }
	void SetDecimal_digits(short x) { this -> decimal_digits = x; }
	short GetNum_prec_radix() { return this -> num_prec_radix; }
	void SetNum_prec_radix(short x) { this -> num_prec_radix = x; }
	short GetNullable() { return this -> nullable; }
	void SetNullable(short x) { this -> nullable = x; }
	const char *GetRemarks() { return this -> remarks.c_str(); }
	void SetRemarks(const std::string&  x) { this -> remarks = x; }
	const char *GetColumn_def() { return this -> column_def.c_str(); }
	void SetColumn_def(const std::string&  x) { this -> column_def = x; }
	short GetSql_data_type() { return this -> sql_data_type; }
	void SetSql_data_type(short x) { this -> sql_data_type = x; }
	short GetSql_datetime_sub() { return this -> sql_datetime_sub; }
	void SetSql_datetime_sub(short x) { this -> sql_datetime_sub = x; }
	long GetChar_octet_length() { return this -> char_octet_length; }
	void SetChar_octet_length(long x) { this -> char_octet_length = x; }
	long GetOrdinal_position() { return this -> ordinal_position; }
	void SetOrdinal_position(long x) { this -> ordinal_position = x; }
	const char *GetIs_nullable() { return this -> is_nullable.c_str(); }
	void SetIs_nullable(const std::string&  x) { this -> is_nullable = x; }

	// table columns
private:
	std::string              table_cat; // varchar(255)
	std::string              table_schem; // varchar(255)
	std::string              table_name; // varchar(255)
	std::string              column_name; // varchar(255)
	short                    data_type; // smallint
	std::string              type_name; // varchar(255)
	long                     column_size; // integer
	long                     buffer_length; // integer
	short                    decimal_digits; // smallint
	short                    num_prec_radix; // smallint
	short                    nullable; // smallint
	std::string              remarks; // varchar(255)
	std::string              column_def; // varchar(255)
	short                    sql_data_type; // smallint
	short                    sql_datetime_sub; // smallint
	long                     char_octet_length; // integer
	long                     ordinal_position; // integer
	std::string              is_nullable; // varchar(255)
	//
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	//
	Database *database;
	short new_object;
}; // End of class 'Odbccolumn'

} // end of namespace

/**
 **  Class 'Odbcspecialcolumn' and 'cOdbcspecialcolumn'
 **/

namespace sql
{
class Odbcspecialcolumn {
public:
	Odbcspecialcolumn(Database *);
	Odbcspecialcolumn(Database *,const std::string& );
	Odbcspecialcolumn(Database *,Query *,int = 0 /* offset */);
	~Odbcspecialcolumn();
	unsigned __int64 insert();
	void save();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	short GetScope() { return this -> scope; }
	void SetScope(short x) { this -> scope = x; }
	const char *GetColumn_name() { return this -> column_name.c_str(); }
	void SetColumn_name(const std::string&  x) { this -> column_name = x; }
	short GetData_type() { return this -> data_type; }
	void SetData_type(short x) { this -> data_type = x; }
	const char *GetType_name() { return this -> type_name.c_str(); }
	void SetType_name(const std::string&  x) { this -> type_name = x; }
	long GetColumn_size() { return this -> column_size; }
	void SetColumn_size(long x) { this -> column_size = x; }
	long GetBuffer_length() { return this -> buffer_length; }
	void SetBuffer_length(long x) { this -> buffer_length = x; }
	short GetDecimal_digits() { return this -> decimal_digits; }
	void SetDecimal_digits(short x) { this -> decimal_digits = x; }
	short GetPseudo_column() { return this -> pseudo_column; }
	void SetPseudo_column(short x) { this -> pseudo_column = x; }

	// table columns
private:
	short                    scope; // smallint
	std::string              column_name; // varchar(255)
	short                    data_type; // smallint
	std::string              type_name; // varchar(255)
	long                     column_size; // integer
	long                     buffer_length; // integer
	short                    decimal_digits; // smallint
	short                    pseudo_column; // smallint
	//
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	//
	Database *database;
	short new_object;
}; // End of class 'Odbcspecialcolumn'

} // end of namespace

/**
 **  Class 'Odbcprimarykey' and 'cOdbcprimarykey'
 **/

namespace sql
{
class Odbcprimarykey {
public:
	Odbcprimarykey(Database *);
	Odbcprimarykey(Database *,const std::string& );
	Odbcprimarykey(Database *,Query *,int = 0 /* offset */);
	~Odbcprimarykey();
	unsigned __int64 insert();
	void save();
	std::string xml();
	std::string xml(const std::string& ,const std::string& );
	size_t num_cols();

	const char *GetTable_cat() { return this -> table_cat.c_str(); }
	void SetTable_cat(const std::string&  x) { this -> table_cat = x; }
	const char *GetTable_schem() { return this -> table_schem.c_str(); }
	void SetTable_schem(const std::string&  x) { this -> table_schem = x; }
	const char *GetTable_name() { return this -> table_name.c_str(); }
	void SetTable_name(const std::string&  x) { this -> table_name = x; }
	const char *GetColumn_name() { return this -> column_name.c_str(); }
	void SetColumn_name(const std::string&  x) { this -> column_name = x; }
	short GetKey_seq() { return this -> key_seq; }
	void SetKey_seq(short x) { this -> key_seq = x; }
	const char *GetPk_name() { return this -> pk_name.c_str(); }
	void SetPk_name(const std::string&  x) { this -> pk_name = x; }

	// table columns
private:
	std::string              table_cat; // varchar(255)
	std::string              table_schem; // varchar(255)
	std::string              table_name; // varchar(255)
	std::string              column_name; // varchar(255)
	short                    key_seq; // smallint
	std::string              pk_name; // varchar(255)
	//
	void clear();
	void spawn(const std::string& );
	void spawn(Query *,int = 0 /* offset */);
	void select(const std::string& );
	//
	Database *database;
	short new_object;
}; // End of class 'Odbcprimarykey'

} // end of namespace
#endif // _LIBODBC_H
